/*
 * Chromosome.cpp
 *
 *  Created on: Feb 18, 2011
 *      Author: Jessica Leigh
 */

#include <string>
#include <sstream>
using namespace std;

#include "Chromosome.h"
#include "DomesticationException.h"

Chromosome::Chromosome(int nloci)
{
  _nloci = nloci;
  _genotype = new bool[_nloci];
  for (int i = 0; i < nloci; i++)  _genotype[i] = false;
}

Chromosome::Chromosome(const Chromosome & other)
{
  _nloci = other.getnloci();
  _genotype = new bool[_nloci];
  
  for (int i = 0; i < _nloci; i++)  _genotype[i] = other.getlocus(i);
}

int Chromosome::getnloci() const
{
  return _nloci;
}

bool Chromosome::getlocus(int idx) const
{
  if (idx < 0 || idx >= _nloci)  
  {
    ostringstream m;
    m << "Invalid locus index: " << idx;
    throw DomesticationException(m.str());
  }
  
  else  return _genotype[idx];
}

void Chromosome::setlocus(int idx, bool value)
{
  if (idx < 0 || idx >= _nloci)  
  {
    ostringstream m;
    m << "Invalid locus index: " << idx;
    throw DomesticationException(m.str());
  }
  
  else  _genotype[idx] = value;
}

const bool * Chromosome::getgenotype() const
{
  return _genotype;
}

Chromosome::~Chromosome()
{
  // TODO Auto-generated destructor stub
  delete _genotype;
}
