/*
 * ChromosomeDistribution.h
 *
 *  Created on: Feb 25, 2011
 *      Author: jleigh
 */
#ifndef CHROMOSOMEDISTRIBUTION_H_
#define CHROMOSOMEDISTRIBUTION_H_

#include <vector>

#include "Chromosome.h"


class ChromosomeDistribution
{
public:
  ChromosomeDistribution(int, const vector<Chromosome*>&);

  void makerandomfreqs();
  const Chromosome* samplehaplotype() const;
  double getfreq(int) const;
  const Chromosome* gethaplotype(int) const;


  virtual ~ChromosomeDistribution();
private:
  int bsearchChromosome(int, int, int) const;

  int _nhaplotypes;
  int _N;
  std::vector<const Chromosome*> _htypes;
  double *_freqs;
  int **_cumufreqranges;
};

#endif /* CHROMOSOMEDISTRIBUTION_H_ */
